@echo off

PATH "C:\FreeBASIC\"

set fbc="fbc32.exe"
set log=".\win32\compile32.log"

set static=Win32 Static Library
set binary=32bit Windows Binary

set guiopts= -s gui ".\win32\rc\puzzlum.rc" 
set debugopts= -g 

if exist %log% (
	del %log%
)

set fbopts=
rem -include ".\const.bas"
set libopts=
rem -lib %fbopts% 

echo: >> %log%
echo ===[ Puzzlum-Win32 ]==[ FreeBASIC x86 Linker Utility ]=== >> %log%

rem echo: >> %log%
rem echo ===[ Constants ]==[ %static% ]=== >> %log%
rem %fbc% "const.bas" %libopts% >> %log% 2>&1

rem echo: >> %log%
rem echo ===[ Puzzlum / Constants ]==[ %static% ]=== >> %log%
rem %fbc% ".\const.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Common ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-common.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / CMD Test ]==[ %static% ]=== >> %log%
rem %fbc% ".\CMD-Poll.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Central Debug ]==[ %static% ]=== >> %log%
rem %fbc% ".\central-debug.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / VGA Table ]==[ %static% ]=== >> %log%
rem %fbc% ".\VGA_Table.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Names Table ]==[ %static% ]=== >> %log%
rem %fbc% ".\Names.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Composite Layer Video ]==[ %static% ]=== >> %log%
rem %fbc% ".\CLV.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ FBImage ]==[ %static% ]=== >> %log%
rem %fbc% ".\fbimage.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Outro ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-outro.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Vars ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-vars.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Loaders ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-loaders.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Subs ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-subs.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Entity Loader ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-entity-loader.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Maps ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-maps.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Map Viewer ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-map-viewer.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Test ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-test.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Profile Manip ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-profile-manip.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

rem echo: >> %log%
rem echo ===[ Puzzlum / Main ]==[ %static% ]=== >> %log%
rem %fbc% ".\puzzlum-main.bas" %debugopts% %libopts% >> %log% 2>&1
rem if errorlevel 1 goto :failed

echo: >> %log%
echo ===[ Story / Win32 ]==[ %binary% ]=== >> %log%
%fbc% ".\story 05a.bas" %debugopts% %fbopts% %guiopts% >> %log% 2>&1
if errorlevel 1 goto :failed

echo: >> %log%
echo ===[ Now attempting to load the "story 05a" executable.. ]=== >> %log%

exit /b 0

:failed
echo failed to compile 1>&2
pause >nul
exit /b 1

:caption
echo ===[ %header% ]==[ %type% ]=== >> %log%
pause >nul
exit /b 1
